package com.zoo.controller;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.zoo.common.R;
import com.zoo.entity.Keeper;
import com.zoo.entity.Veterinary;
import com.zoo.service.IVeterinaryService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author DJ
 * @since 2024-05-17
 */
@RestController
@RequestMapping("/zoo/veterinary")
public class VeterinaryController {
    @Autowired
    IVeterinaryService iVeterinaryService;
    @GetMapping("info")
    public R info(Integer roleid){
        if (roleid!=null){
            QueryWrapper<Veterinary> queryWrapper = new QueryWrapper<>();
            queryWrapper.eq("roleid",roleid);
            Veterinary veterinary = iVeterinaryService.getOne(queryWrapper);
            return R.success(veterinary);
        }
        List<Veterinary> list = iVeterinaryService.list();
        return R.success(list);
    }
    @PostMapping("/add")
    public R add(Veterinary veterinary){
        boolean save = iVeterinaryService.save(veterinary);
        if (save){
            return R.success("添加成功");
        }
        return R.error("添加失败");
    }

    @PostMapping("/update")
    public R update(Veterinary veterinary){
        QueryWrapper<Veterinary> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("roleid",veterinary.getRoleid());
        boolean b = iVeterinaryService.update(veterinary,queryWrapper);
        if (b){
            return R.success("修改成功");
        }
        return R.error("修改失败");
    }
    @GetMapping("/delete")
    public R delete(Integer roleid){
        QueryWrapper<Veterinary> queryWrapper = new QueryWrapper<>();
        queryWrapper.eq("roleid",roleid);
        boolean b = iVeterinaryService.remove(queryWrapper);
        if (b){
            return R.success("删除成功");
        }
        return R.error("删除失败");
    }
}
